=begin
#Cloudera DataBus Service

#Cloudera DataBus Service is a data transport infrastructure.

OpenAPI spec version: 0.1-SNAPSHOT

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.27

=end

require 'uri'

module Dbus
  class DefaultApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Put a single record.
    # Put a single record into the DataBus.
    # @param input 
    # @param [Hash] opts the optional parameters
    # @return [PutRecordResponse]
    def put_record(input, opts = {})
      data, _status_code, _headers = put_record_with_http_info(input, opts)
      data
    end

    # Put a single record.
    # Put a single record into the DataBus.
    # @param input 
    # @param [Hash] opts the optional parameters
    # @return [Array<(PutRecordResponse, Fixnum, Hash)>] PutRecordResponse data, response status code and response headers
    def put_record_with_http_info(input, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: DefaultApi.put_record ...'
      end
      # verify the required parameter 'input' is set
      if @api_client.config.client_side_validation && input.nil?
        fail ArgumentError, "Missing the required parameter 'input' when calling DefaultApi.put_record"
      end
      # resource path
      local_var_path = '/dbus/putRecord'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(input)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PutRecordResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DefaultApi#put_record\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Test put a new record.
    # Test put a new record.
    # @param input 
    # @param [Hash] opts the optional parameters
    # @return [TestPutRecordResponse]
    def test_put_record(input, opts = {})
      data, _status_code, _headers = test_put_record_with_http_info(input, opts)
      data
    end

    # Test put a new record.
    # Test put a new record.
    # @param input 
    # @param [Hash] opts the optional parameters
    # @return [Array<(TestPutRecordResponse, Fixnum, Hash)>] TestPutRecordResponse data, response status code and response headers
    def test_put_record_with_http_info(input, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: DefaultApi.test_put_record ...'
      end
      # verify the required parameter 'input' is set
      if @api_client.config.client_side_validation && input.nil?
        fail ArgumentError, "Missing the required parameter 'input' when calling DefaultApi.test_put_record"
      end
      # resource path
      local_var_path = '/dbus/testPutRecord'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(input)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'TestPutRecordResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DefaultApi#test_put_record\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
